## spfft 1.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18 FATAL_ERROR) # 3.18 for C++17
project(SpFFT LANGUAGES CXX VERSION 1.1.0)
set(SPFFT_SO_VERSION 1)
set(SPFFT_VERSION ${PROJECT_VERSION})

# allow {module}_ROOT variables to be set
if(POLICY CMP0074)
	cmake_policy(SET CMP0074 NEW)
endif()

# Initialize CMAKE_CUDA_ARCHITECTURES through nvcc if possible
if(POLICY CMP0104)
	cmake_policy(SET CMP0104 NEW)
endif()

# set default build type to RELEASE
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type" FORCE)
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
		"Debug" "Release" "MinSizeRel" "RelWithDebInfo"
		)
endif()

# set language and standard
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CUDA_STANDARD 17)
set(CMAKE_HIP_STANDARD 17)

#add local module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake/modules)

include(CMakeDependentOption)

# Options
option(SPFFT_STATIC "Compile as static library" OFF)
option(SPFFT_OMP "Compile with OpenMP support" ON)
option(SPFFT_MPI "Compile with MPI support" ON)
option(SPFFT_GPU_DIRECT "Compile with GPU direct (GPU aware MPI) support." OFF)
option(SPFFT_BUILD_TESTS "Build tests" OFF)
option(SPFFT_SINGLE_PRECISION "Enable single precision support" OFF)
option(SPFFT_INSTALL "Enable CMake install commands" ON)
option(SPFFT_FORTRAN "Compile fortran module" OFF)
option(SPFFT_BUNDLED_LIBS "Use bundled libraries for building tests" ON)

cmake_dependent_option(SPFFT_BUNDLED_GOOGLETEST "Use bundled googletest lib" ON "SPFFT_BUNDLED_LIBS" OFF)
cmake_dependent_option(SPFFT_BUNDLED_JSON "Use bundled json lib" ON "SPFFT_BUNDLED_LIBS" OFF)
cmake_dependent_option(SPFFT_BUNDLED_CLI11 "Use bundled CLI11 lib" ON "SPFFT_BUNDLED_LIBS" OFF)

set(SPFFT_GPU_BACKEND "OFF" CACHE STRING "GPU backend")
set_property(CACHE SPFFT_GPU_BACKEND PROPERTY STRINGS
	"OFF" "CUDA" "ROCM"
	)

set(SPFFT_FFTW_LIB "AUTO" CACHE STRING "Library providing a FFTW interface")
set_property(CACHE SPFFT_FFTW_LIB PROPERTY STRINGS
	"AUTO" "FFTW" "MKL" "ARMPL"
	)

# Get GNU standard install prefixes
include(GNUInstallDirs)

# set preferred library type
if (SPFFT_STATIC)
	# prefer static over dynamic libraries with the find_library() command by changing the order
	set(CMAKE_FIND_LIBRARY_SUFFIXES_SAVE ${CMAKE_FIND_LIBRARY_SUFFIXES})
	if(APPLE)
		set(CMAKE_FIND_LIBRARY_SUFFIXES .a .tbd .dylib .so)
	elseif(UNIX)
		set(CMAKE_FIND_LIBRARY_SUFFIXES .a .so)
	endif()
	set(SPFFT_LIBRARY_TYPE STATIC)
else()
	set(SPFFT_LIBRARY_TYPE SHARED)
endif()

set(SPFFT_EXTERNAL_LIBS)
set(SPFFT_INCLUDE_DIRS)
set(SPFFT_EXTERNAL_INCLUDE_DIRS)
set(SPFFT_EXTERNAL_PKG_PACKAGES)

# Options combination check
set(SPFFT_CUDA OFF)
set(SPFFT_ROCM OFF)
if(SPFFT_GPU_BACKEND)
	if(SPFFT_GPU_BACKEND STREQUAL "CUDA")
		set(SPFFT_CUDA ON)
	elseif(SPFFT_GPU_BACKEND STREQUAL "ROCM")
		set(SPFFT_ROCM ON)
	else()
		message(FATAL_ERROR "Invalid GPU backend option")
	endif()
endif()
mark_as_advanced(SPFFT_CUDA SPFFT_ROCM)

# Fortran
if(SPFFT_FORTRAN)
	enable_language(Fortran)
endif()

# CUDA
if(SPFFT_CUDA)
	enable_language(CUDA)

	if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.17.0") 
		find_package(CUDAToolkit REQUIRED)
	else()
		find_library(CUDA_CUDART_LIBRARY cudart PATHS ${CMAKE_CUDA_IMPLICIT_LINK_DIRECTORIES})
		find_library(CUDA_CUFFT_LIBRARY cufft PATHS ${CMAKE_CUDA_IMPLICIT_LINK_DIRECTORIES})
		if(NOT TARGET CUDA::cudart)
			add_library(CUDA::cudart INTERFACE IMPORTED)
		endif()
		set_property(TARGET CUDA::cudart PROPERTY INTERFACE_LINK_LIBRARIES ${CUDA_CUDART_LIBRARY})
		set_property(TARGET CUDA::cudart PROPERTY INTERFACE_INCLUDE_DIRECTORIES ${CMAKE_CUDA_TOOLKIT_INCLUDE_DIRECTORIES})
		if(NOT TARGET CUDA::cufft)
			add_library(CUDA::cufft INTERFACE IMPORTED)
		endif()
		set_property(TARGET CUDA::cufft PROPERTY INTERFACE_LINK_LIBRARIES ${CUDA_CUFFT_LIBRARY})
		set_property(TARGET CUDA::cufft PROPERTY INTERFACE_INCLUDE_DIRECTORIES ${CMAKE_CUDA_TOOLKIT_INCLUDE_DIRECTORIES})
	endif()

	list(APPEND SPFFT_EXTERNAL_LIBS CUDA::cudart CUDA::cufft)
endif()

# ROCM
if(SPFFT_ROCM)
	cmake_minimum_required(VERSION 3.21 FATAL_ERROR) # hip support only added in 3.21

	enable_language(HIP)

	find_package(hip CONFIG REQUIRED)
	find_package(rocfft CONFIG REQUIRED)
	find_package(hipfft CONFIG) # hipfft within rocfft is deprecated. Use separate hipfft if available (not required).

	if(hipfft_FOUND)
		# Issue with rocm 4.1.0: Symlink to rocfft provided hipfft.h in /opt/rocm/include.
		# Workaround: Only use hipfft include directory with hipfft target and place before other hip targets in lib list
		if(HIPFFT_INCLUDE_DIRS)
			set_property(TARGET hip::hipfft PROPERTY INTERFACE_INCLUDE_DIRECTORIES ${HIPFFT_INCLUDE_DIRS})
		endif()
		list(APPEND SPFFT_EXTERNAL_LIBS hip::hipfft)
	endif()

	list(APPEND SPFFT_EXTERNAL_LIBS hip::host roc::rocfft)

	# Previously used option for flags.
	if(HIP_HCC_FLAGS)
		message(WARNING "HIP_HCC_FLAGS has no effect. Use CMAKE_HIP_FLAGS for flags and CMAKE_HIP_ARCHITECTURES for arch instead.")
	endif()
endif()

if(SPFFT_MPI)
	find_package(MPI COMPONENTS CXX REQUIRED)
	list(APPEND SPFFT_EXTERNAL_LIBS MPI::MPI_CXX)
endif()

if(SPFFT_OMP)
	find_package(OpenMP COMPONENTS CXX REQUIRED)
	list(APPEND SPFFT_EXTERNAL_LIBS OpenMP::OpenMP_CXX)
endif()

if(SPFFT_GPU_DIRECT)
	message(STATUS "GPU Direct support enabled: Additional environment variables might have to be set before execution. (e.g \"export MPICH_RDMA_ENABLED_CUDA=1\")")
endif()


# FFTW library must be found if not set to AUTO
set(_SPFFT_FIND_FFTW_LIB_OPTION)
if(NOT ${SPFFT_FFTW_LIB} STREQUAL "AUTO")
	set(_SPFFT_FIND_FFTW_LIB_OPTION REQUIRED)
endif()

set(SPFFT_MKL OFF)
set(SPFFT_ARMPL OFF)
set(SPFFT_FFTW OFF)

# Look for MKL first
if(${SPFFT_FFTW_LIB} STREQUAL "AUTO" OR ${SPFFT_FFTW_LIB} STREQUAL "MKL")
	# Use MKL if available, otherwise require FFTW3
	if(UNIX AND NOT APPLE)
		# prefer static MKL in Linux. Together with "-Wl,--exclude-libs,ALL",
		# symbols are not visible for linking afterwards and no conflicts with other MKL versions of other libraries should exist.
		set(_TMP_SAVE ${CMAKE_FIND_LIBRARY_SUFFIXES})
		set(CMAKE_FIND_LIBRARY_SUFFIXES .a .so)
	endif()
	find_package(MKLSequential ${_SPFFT_FIND_FFTW_LIB_OPTION})
	if(UNIX AND NOT APPLE)
		set(CMAKE_FIND_LIBRARY_SUFFIXES ${_TMP_SAVE})
		unset(_TMP_SAVE)
	endif()
	if(TARGET MKL::Sequential)
		list(APPEND SPFFT_EXTERNAL_LIBS MKL::Sequential)
		list(APPEND SPFFT_EXTERNAL_PKG_PACKAGES mkl-dynamic-lp64-seq)
		set(SPFFT_MKL ON)
	endif()
endif()


# Look for ARM PL
if(NOT SPFFT_MKL AND ${SPFFT_FFTW_LIB} STREQUAL "AUTO" OR ${SPFFT_FFTW_LIB} STREQUAL "ARMPL")
	find_package(ARMPL ${_SPFFT_FIND_FFTW_LIB_OPTION})
	if(TARGET ARM::pl)
		list(APPEND SPFFT_EXTERNAL_LIBS ARM::pl)
		set(SPFFT_ARMPL ON)
	endif()
endif()

# Look for FFTW library if required
if(NOT SPFFT_MKL AND NOT SPFFT_ARMPL)
	find_package(FFTW REQUIRED)
	list(APPEND SPFFT_EXTERNAL_LIBS FFTW::FFTW)
	if(SPFFT_SINGLE_PRECISION)
		find_package(FFTWF REQUIRED)
		list(APPEND SPFFT_EXTERNAL_LIBS FFTWF::FFTWF)
	endif()
	list(APPEND SPFFT_EXTERNAL_PKG_PACKAGES fftw3)
	set(SPFFT_FFTW ON)
endif()


# generate config.h
configure_file(include/spfft/config.h.in ${PROJECT_BINARY_DIR}/spfft/config.h)

list(APPEND SPFFT_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/src)
list(APPEND SPFFT_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/include)
list(APPEND SPFFT_INCLUDE_DIRS ${PROJECT_BINARY_DIR})
list(APPEND SPFFT_EXTERNAL_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/ext)

#############################################################################
# All include dirs and definitions must be set before sub-directory is added!
#############################################################################
add_subdirectory(src)

# add tests for developement
if(SPFFT_BUILD_TESTS)
	add_subdirectory(tests)
endif()

# reset cmake library suffixes
if(SPFFT_STATIC)
	set(CMAKE_FIND_LIBRARY_SUFFIXES ${CMAKE_FIND_LIBRARY_SUFFIXES_SAVE})
endif()

=== docs/requirements.txt ===
breathe
sphinx-rtd-theme

=== src/CMakeLists.txt ===
set(SPFFT_SOURCE_FILES
	memory/aligned_allocation.cpp
	timing/timing.cpp
	timing/rt_graph.cpp
	parameters/parameters.cpp
	execution/execution_host.cpp
	spfft/transform.cpp
	spfft/transform_internal.cpp
	spfft/multi_transform.cpp
	spfft/grid.cpp
	spfft/grid_internal.cpp
	fft/fftw_mutex.cpp
	)

if(SPFFT_SINGLE_PRECISION)
	list(APPEND SPFFT_SOURCE_FILES
		spfft/transform_float.cpp
		spfft/multi_transform_float.cpp
		spfft/grid_float.cpp
		)
endif()

set(SPFFT_GPU_KERNELS)
if(SPFFT_CUDA OR SPFFT_ROCM)
	list(APPEND SPFFT_GPU_KERNELS
		transpose/gpu_kernels/local_transpose_kernels.cu
		compression/gpu_kernels/compression_kernels.cu
		symmetry/gpu_kernels/symmetry_kernels.cu
		transpose/gpu_kernels/buffered_kernels.cu
		transpose/gpu_kernels/compact_buffered_kernels.cu
		)
	list(APPEND SPFFT_SOURCE_FILES
		execution/execution_gpu.cpp
		gpu_util/gpu_fft_api.cpp
		)
	if(SPFFT_MPI)
		list(APPEND SPFFT_SOURCE_FILES
			transpose/transpose_mpi_buffered_gpu.cpp
			transpose/transpose_mpi_compact_buffered_gpu.cpp
			transpose/transpose_mpi_unbuffered_gpu.cpp
			)
	endif()

	if(SPFFT_ROCM)
		set_source_files_properties(${SPFFT_GPU_KERNELS} PROPERTIES LANGUAGE HIP)
	endif()

	list(APPEND SPFFT_SOURCE_FILES ${SPFFT_GPU_KERNELS})
endif()

if(SPFFT_MPI)
	list(APPEND SPFFT_SOURCE_FILES
		transpose/transpose_mpi_buffered_host.cpp
		transpose/transpose_mpi_compact_buffered_host.cpp
		transpose/transpose_mpi_unbuffered_host.cpp
		)
endif()

# Creates library with given name. All common target modifications should be done here.
macro(spfft_create_library _TARGET_NAME)
	# create target
	add_library(${_TARGET_NAME} ${SPFFT_LIBRARY_TYPE} ${SPFFT_SOURCE_FILES})

	# set version
	set_property(TARGET ${_TARGET_NAME} PROPERTY VERSION ${SPFFT_VERSION})
	set_property(TARGET ${_TARGET_NAME} PROPERTY SOVERSION ${SPFFT_SO_VERSION})

	# All .cu files are self-contained. Device linking can have issues with propageted linker flags of other targets like MPI.
	if(SPFFT_CUDA)
		set_property(TARGET ${_TARGET_NAME} PROPERTY CUDA_RESOLVE_DEVICE_SYMBOLS OFF)
		set_property(TARGET ${_TARGET_NAME} PROPERTY CUDA_SEPARABLE_COMPILATION OFF)
	endif()
	if(SPFFT_ROCM)
		target_compile_options(${_TARGET_NAME} PRIVATE $<$<COMPILE_LANGUAGE:HIP>:-fno-gpu-rdc>)
	endif()

	# Don't export any symbols of external static libaries. Only works on linux.
	if(UNIX AND NOT APPLE)
		if(${CMAKE_VERSION} VERSION_LESS "3.13.5") 
			target_link_libraries(${_TARGET_NAME} PRIVATE "-Wl,--exclude-libs,ALL")
		else()
			target_link_options(${_TARGET_NAME} PRIVATE "-Wl,--exclude-libs,ALL")
		endif()
	endif()

	target_include_directories(${_TARGET_NAME} PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})
	target_link_libraries(${_TARGET_NAME} PRIVATE ${SPFFT_EXTERNAL_LIBS})

	target_include_directories(${_TARGET_NAME} INTERFACE $<INSTALL_INTERFACE:include>) # for install(EXPORT ...)
	target_include_directories(${_TARGET_NAME} INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>) # for export(...)
	if(${SPFFT_FORTRAN}) # Add include directory for fortran module
		target_include_directories(${_TARGET_NAME} INTERFACE $<INSTALL_INTERFACE:include/spfft>)
		target_include_directories(${_TARGET_NAME} INTERFACE $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>)
	endif()

endmacro()

# Create library
spfft_create_library(spfft)
set_target_properties(spfft PROPERTIES VISIBILITY_INLINES_HIDDEN TRUE CXX_VISIBILITY_PRESET hidden)

# Create library for testing, which allows linking to internal symbols and has timings enabled.
if(SPFFT_BUILD_TESTS)
	spfft_create_library(spfft_test)
	set_target_properties(spfft_test PROPERTIES VISIBILITY_INLINES_HIDDEN FALSE CXX_VISIBILITY_PRESET default)
	target_compile_options(spfft_test PUBLIC -DSPFFT_STATIC_DEFINE) # disable properties of export header
	# enable internal timings
	target_compile_options(spfft_test PUBLIC -DSPFFT_TIMING)
endif()

# build fortran module
if(SPFFT_FORTRAN)
	add_library(spfft_fortran OBJECT ${PROJECT_SOURCE_DIR}/include/spfft/spfft.f90)
endif()

# generate export header to control symbol visibility
include(GenerateExportHeader)
generate_export_header(spfft)
configure_file("${CMAKE_CURRENT_BINARY_DIR}/spfft_export.h"
	"${PROJECT_BINARY_DIR}/spfft/spfft_export.h"
	COPYONLY
)

# set packge config names
get_target_property(_LIB_TYPE spfft TYPE)
if(_LIB_TYPE STREQUAL "STATIC_LIBRARY")
	set(SPFFT_VERSION_FILE "SpFFTStaticConfigVersion.cmake")
	set(SPFFT_CONFIG_FILE "SpFFTStaticConfig.cmake")
	set(SPFFT_TARGETS_FILE "SpFFTStaticTargets.cmake")
else()
	set(SPFFT_VERSION_FILE "SpFFTSharedConfigVersion.cmake")
	set(SPFFT_CONFIG_FILE "SpFFTSharedConfig.cmake")
	set(SPFFT_TARGETS_FILE "SpFFTSharedTargets.cmake")
endif()


# generate cmake package
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
	"${PROJECT_BINARY_DIR}/${SPFFT_VERSION_FILE}"
	VERSION ${Upstream_VERSION}
	COMPATIBILITY AnyNewerVersion
)
export(TARGETS spfft NAMESPACE SpFFT:: FILE ${PROJECT_BINARY_DIR}/${SPFFT_TARGETS_FILE})
configure_file(${PROJECT_SOURCE_DIR}/cmake/${SPFFT_CONFIG_FILE}
	"${PROJECT_BINARY_DIR}/${SPFFT_CONFIG_FILE}"
	@ONLY
)
configure_file(${PROJECT_SOURCE_DIR}/cmake/SpFFTConfig.cmake
	"${PROJECT_BINARY_DIR}/SpFFTConfig.cmake"
	COPYONLY
)
configure_file(${PROJECT_SOURCE_DIR}/cmake/SpFFTConfigVersion.cmake
	"${PROJECT_BINARY_DIR}/SpFFTConfigVersion.cmake"
	COPYONLY
)
configure_file(${PROJECT_SOURCE_DIR}/cmake/SpFFTTargets.cmake
	"${PROJECT_BINARY_DIR}/SpFFTTargets.cmake"
	COPYONLY
)
configure_file(${PROJECT_SOURCE_DIR}/cmake/SpFFT.pc.in
	"${PROJECT_BINARY_DIR}/SpFFT.pc"
	@ONLY
)

# installation commands
if(SPFFT_INSTALL)
	install(TARGETS spfft DESTINATION ${CMAKE_INSTALL_LIBDIR} EXPORT SpFFTTargets)
	install(DIRECTORY ${PROJECT_SOURCE_DIR}/include/spfft DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp" PATTERN "*.f90")
	install(FILES ${PROJECT_BINARY_DIR}/spfft/config.h "${PROJECT_BINARY_DIR}/spfft/spfft_export.h" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/spfft)
	install(EXPORT SpFFTTargets NAMESPACE SpFFT:: DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/SpFFT FILE ${SPFFT_TARGETS_FILE})
	install(
	  FILES
		"${PROJECT_BINARY_DIR}/SpFFTConfig.cmake"
		"${PROJECT_BINARY_DIR}/SpFFTTargets.cmake"
		"${PROJECT_BINARY_DIR}/SpFFTConfigVersion.cmake"
		"${PROJECT_BINARY_DIR}/${SPFFT_CONFIG_FILE}"
		"${PROJECT_BINARY_DIR}/${SPFFT_VERSION_FILE}"
	  DESTINATION
	    ${CMAKE_INSTALL_LIBDIR}/cmake/SpFFT
	)

	install(FILES ${PROJECT_BINARY_DIR}/SpFFT.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

	install(DIRECTORY "${PROJECT_SOURCE_DIR}/cmake/modules"
		DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/SpFFT"
        FILES_MATCHING PATTERN "*.cmake")

	if(SPFFT_FORTRAN)
		install(FILES ${PROJECT_BINARY_DIR}/src/spfft.mod DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/spfft)
	endif()
endif()

=== tests/CMakeLists.txt ===

if(SPFFT_BUILD_TESTS)
	cmake_minimum_required(VERSION 3.14 FATAL_ERROR) # FetchContent_MakeAvailable requires at least 3.14

	# update time stamps when using FetchContent
	if(POLICY CMP0135)
		cmake_policy(SET CMP0135 NEW)
	endif()

	set(BUILD_GMOCK OFF CACHE BOOL "")
	set(INSTALL_GTEST OFF CACHE BOOL "")
	mark_as_advanced(BUILD_GMOCK INSTALL_GTEST)
	include(FetchContent)

	# add googletest
	if(SPFFT_BUNDLED_GOOGLETEST)
		FetchContent_Declare(
			googletest
			URL https://github.com/google/googletest/archive/refs/tags/v1.14.0.tar.gz
			URL_MD5 c8340a482851ef6a3fe618a082304cfc
		)
		FetchContent_MakeAvailable(googletest)
	else()
	  find_package(googletest CONFIG REQUIRED)
	endif()
	list(APPEND SPFFT_TEST_LIBRARIES gtest_main)

	# add command line parser
	if(SPFFT_BUNDLED_CLI11)
		FetchContent_Declare(
			cli11
			URL https://github.com/CLIUtils/CLI11/archive/refs/tags/v2.3.2.tar.gz
			URL_MD5 b80cb645dee25982110b068b426363ff
		)
		FetchContent_MakeAvailable(cli11)
	else()
		find_package(CLI11 CONFIG REQUIRED)
	endif()
	list(APPEND SPFFT_TEST_LIBRARIES CLI11::CLI11)

  # add json parser
	if(SPFFT_BUNDLED_JSON)
	  FetchContent_Declare(
		json
		URL https://github.com/nlohmann/json/archive/refs/tags/v3.11.2.tar.gz
		URL_MD5 e8d56bc54621037842ee9f0aeae27746
	  )
	  FetchContent_MakeAvailable(json)
	else()
	  find_package(nlohmann_json CONFIG REQUIRED)
	endif()

	list(APPEND SPFFT_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/tests)

	# benchmark executable
	add_executable(benchmark programs/benchmark.cpp)
	target_link_libraries(benchmark PRIVATE spfft_test ${SPFFT_EXTERNAL_LIBS} CLI11::CLI11 nlohmann_json::nlohmann_json)
	target_include_directories(benchmark PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})

	# test executables
	add_executable(run_local_tests
		run_local_tests.cpp
		local_tests/test_host_array.cpp
		local_tests/test_disjoint.cpp
		local_tests/test_fftw_prop_hash.cpp
		local_tests/test_local_transform.cpp
		)
	target_link_libraries(run_local_tests PRIVATE gtest_main)
	target_link_libraries(run_local_tests PRIVATE spfft_test ${SPFFT_EXTERNAL_LIBS})
	target_include_directories(run_local_tests PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})

	if(SPFFT_MPI)
		add_executable(run_mpi_tests
			run_mpi_tests.cpp
			gtest_mpi.cpp
			mpi_tests/test_transform.cpp
			mpi_tests/test_multi_transform.cpp
			mpi_tests/test_transpose.cpp
			mpi_tests/test_transpose_gpu.cpp
			)
		target_link_libraries(run_mpi_tests PRIVATE gtest_main)
		target_link_libraries(run_mpi_tests PRIVATE spfft_test ${SPFFT_EXTERNAL_LIBS})
		target_include_directories(run_mpi_tests PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})
	endif()

endif()

=== debian/changelog ===
spfft (1.1.0-1build2) plucky; urgency=medium

  * No-change rebuild for openmpi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 30 Nov 2024 08:03:57 +0100

spfft (1.1.0-1build1) oracular; urgency=medium

  * No-change rebuild against mpi-defaults 1.17

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Thu, 01 Aug 2024 09:04:07 -0700

spfft (1.1.0-1) unstable; urgency=medium

  * New upstream version 1.1.0
  * Fix debian/watch.
  * Bump copyright year.
  * Drop superfluous copyright stanza.

 -- Andrius Merkys <merkys@debian.org>  Thu, 20 Jun 2024 03:39:27 -0400

## spfft 1.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.18 FATAL_ERROR) # 3.18 for C++17
-project(SpFFT LANGUAGES CXX VERSION 1.1.0)
+project(SpFFT LANGUAGES CXX VERSION 1.1.1)
 set(SPFFT_SO_VERSION 1)
 set(SPFFT_VERSION ${PROJECT_VERSION})

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -16,14 +16,13 @@
 	if(SPFFT_BUNDLED_GOOGLETEST)
 		FetchContent_Declare(
 			googletest
-			URL https://github.com/google/googletest/archive/refs/tags/v1.14.0.tar.gz
-			URL_MD5 c8340a482851ef6a3fe618a082304cfc
+			URL https://github.com/google/googletest/archive/refs/tags/v1.15.2.tar.gz
+			URL_MD5 7e11f6cfcf6498324ac82d567dcb891e
 		)
 		FetchContent_MakeAvailable(googletest)
 	else()
-	  find_package(googletest CONFIG REQUIRED)
+	  find_package(GTest CONFIG REQUIRED)
 	endif()
-	list(APPEND SPFFT_TEST_LIBRARIES gtest_main)
 
 	# add command line parser
 	if(SPFFT_BUNDLED_CLI11)
@@ -36,7 +35,6 @@
 	else()
 		find_package(CLI11 CONFIG REQUIRED)
 	endif()
-	list(APPEND SPFFT_TEST_LIBRARIES CLI11::CLI11)
 
   # add json parser
 	if(SPFFT_BUNDLED_JSON)
@@ -65,7 +63,7 @@
 		local_tests/test_fftw_prop_hash.cpp
 		local_tests/test_local_transform.cpp
 		)
-	target_link_libraries(run_local_tests PRIVATE gtest_main)
+	target_link_libraries(run_local_tests PRIVATE GTest::gtest)
 	target_link_libraries(run_local_tests PRIVATE spfft_test ${SPFFT_EXTERNAL_LIBS})
 	target_include_directories(run_local_tests PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})
 
@@ -78,7 +76,7 @@
 			mpi_tests/test_transpose.cpp
 			mpi_tests/test_transpose_gpu.cpp
 			)
-		target_link_libraries(run_mpi_tests PRIVATE gtest_main)
+		target_link_libraries(run_mpi_tests PRIVATE GTest::gtest)
 		target_link_libraries(run_mpi_tests PRIVATE spfft_test ${SPFFT_EXTERNAL_LIBS})
 		target_include_directories(run_mpi_tests PRIVATE ${SPFFT_INCLUDE_DIRS} ${SPFFT_EXTERNAL_INCLUDE_DIRS})
 	endif()

=== debian/changelog ===
spfft (1.1.1-4) unstable; urgency=medium

  * Remove hardcoded clang++ version from debian/rules (Closes: #1118976)

 -- Andrius Merkys <merkys@debian.org>  Mon, 27 Oct 2025 04:22:45 -0400

spfft (1.1.1-3) unstable; urgency=medium

  * Fix co-installation failure of libspfft-dev (Closes: #1100920).
    Thanks Helmut Grohne.

 -- Andrius Merkys <merkys@debian.org>  Thu, 20 Mar 2025 11:31:09 -0400

spfft (1.1.1-2) unstable; urgency=medium

  [ Utkarsh Raj ]
  * Set SPFFT_GPU_BACKEND=ROCM for amd64, arm64, ppc64el.
  * Add ROCm build dependencies, limited to amd64, arm64, ppc64el.
  * Build for all supported GPU architectures. 

 -- Andrius Merkys <merkys@debian.org>  Tue, 18 Mar 2025 12:16:21 -0400

spfft (1.1.1-1) unstable; urgency=medium

  * New upstream version 1.1.1
  * Bump copyright years.
  * Remove RUNPATH setting with chrpath.

 -- Andrius Merkys <merkys@debian.org>  Thu, 23 Jan 2025 07:10:46 -0500

=== debian/control ===
Source: spfft
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
# ROCm-related dependencies are available only on supported architectures
Build-Depends:
 chrpath,
 cmake,
 debhelper-compat (= 13),
 libfftw3-dev,
 mpi-default-dev,
 librocfft-dev [arm64 amd64 ppc64el],
 libhipfft-dev [arm64 amd64 ppc64el],
 hipcc [arm64 amd64 ppc64el]
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://github.com/eth-cscs/SpFFT
Vcs-Browser: https://salsa.debian.org/science-team/spfft
Vcs-Git: https://salsa.debian.org/science-team/spfft.git

Package: libspfft-dev
Section: libdevel
Architecture: any
Depends:
 libspfft1 (= ${binary:Version}),
 ${misc:Depends},
Description: Sparse 3D FFT library with MPI, OpenMP, CUDA / ROCm support (development files)
 SpFFT was originally intended for transforms of data with spherical cutoff in
 frequency domain, as required by some computational material science codes.
 For distributed computations, SpFFT uses a slab decomposition in space domain
 and pencil decomposition in frequency domain (all sparse data within a pencil
 must be on one rank). If desired, the library can be compiled without any
 parallelization (MPI, OpenMP, CUDA / ROCm).
 .
 This package contains development files.

Package: libspfft1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Sparse 3D FFT library with MPI, OpenMP, CUDA / ROCm support
 SpFFT was originally intended for transforms of data with spherical cutoff in
 frequency domain, as required by some computational material science codes.
 For distributed computations, SpFFT uses a slab decomposition in space domain
 and pencil decomposition in frequency domain (all sparse data within a pencil
 must be on one rank). If desired, the library can be compiled without any
 parallelization (MPI, OpenMP, CUDA / ROCm).

=== debian/rules ===
#!/usr/bin/make -f

# Enabling ROCm support for AMD GPUs
export HIPCXX=clang-$(shell /usr/bin/hipcc --version | sed -nr 's/.*clang version ([0-9]+).*/\1/p')
ARCH_HIP_CPU := amd64 arm64 ppc64el
ARCH_HIP_GPU := gfx803;gfx900;gfx906;gfx908;gfx90a;gfx1010;gfx1030;gfx1100;gfx1101;gfx1102
HIP := $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_HIP_CPU)), -DSPFFT_GPU_BACKEND=ROCM "-DCMAKE_HIP_ARCHITECTURES=$(ARCH_HIP_GPU)",)

CMAKE_FLAGS = $(HIP)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

execute_after_dh_auto_install:
	find debian/tmp -name libspfft.so | xargs chrpath --delete

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%spfft-$1.tar.gz%" \
 https://github.com/eth-cscs/SpFFT/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
